diff --git a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
index 9d8490f35..5cb6b3174 100644
--- a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -309,7 +312,7 @@ public class GameSettings {
 		saveOptions();
 	}
 
-	public String getDisplayString(Option<?> option) {
+	public @NotNull String getDisplayString(Option<?> option) {
 		if (option == null) return "";
 		I18n trans = I18n.getInstance();
 		if (option instanceof OptionFloat) {
@@ -453,7 +456,7 @@ public class GameSettings {
 			
 			return trans.translateKey("options." + optionEnum.name+"." + key);
 		}
-		return option.value.toString();
+		return emptyStringIfNull(option.value.toString());
 	}
 
 	public void optionChanged(Option<?> option) {
diff --git a/game/client/src/main/java/net/minecraft/client/option/KeyBinding.java b/game/client/src/main/java/net/minecraft/client/option/KeyBinding.java
index f38de4f2f..62ed5f654 100644
--- a/game/client/src/main/java/net/minecraft/client/option/KeyBinding.java
+++ b/game/client/src/main/java/net/minecraft/client/option/KeyBinding.java
@@ -5,6 +5,8 @@ import java.util.Map;
 
 import net.minecraft.client.input.InputDevice;
 import net.minecraft.core.lang.I18n;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class KeyBinding {
 	private static Map<Character, InputDevice> charToInputDeviceMap = new HashMap<>();
@@ -28,10 +30,10 @@ public class KeyBinding {
 	
 	private final String id;
 	
-	private InputDevice inputDevice;
+	private @Nullable InputDevice inputDevice;
 	private int keyCode = -1;
 
-	private InputDevice defaultInputDevice = null;
+	private @Nullable InputDevice defaultInputDevice = null;
 	private int defaultKeyCode = -1;
 
 	public KeyBinding(String id) {
@@ -41,7 +43,7 @@ public class KeyBinding {
 		GameSettings.keys.add(this);
 	}
 
-	public KeyBinding setDefault(InputDevice device, int keyCode) {
+	public @NotNull KeyBinding setDefault(final @Nullable InputDevice device, final int keyCode) {
 		if(device != null && !device.isKeyCodeValid(keyCode)) {
 			throw new RuntimeException("Key code " + keyCode + " is not valid for input device " + device);
 		}
@@ -49,26 +51,26 @@ public class KeyBinding {
 		this.defaultInputDevice = device;
 		this.defaultKeyCode = keyCode;
 		
-		return bind(device, keyCode);
+		return this.bind(device, keyCode);
 	}
 	
-	public KeyBinding bind(InputDevice device, int keyCode) {
-		if(device.isKeyCodeValid(keyCode)) {
+	public @NotNull KeyBinding bind(final @Nullable InputDevice device, final int keyCode) {
+		if(device != null && device.isKeyCodeValid(keyCode)) {
 			this.keyCode = keyCode;
 			this.inputDevice = device;	
-		}else {
-			unbind();
+		} else {
+            this.unbind();
 		}
 		return this;
 	}
 	
-	public KeyBinding unbind() {
+	public @NotNull KeyBinding unbind() {
 		this.keyCode = -1;
 		this.inputDevice = null;
 		return this;
 	}
 
-	public KeyBinding resetToDefault() {
+	public @NotNull KeyBinding resetToDefault() {
 		this.keyCode = defaultKeyCode;
 		this.inputDevice = defaultInputDevice;
 		return this;
diff --git a/game/client/src/main/java/net/minecraft/client/option/Option.java b/game/client/src/main/java/net/minecraft/client/option/Option.java
index 7291ae77c..c76c55881 100644
--- a/game/client/src/main/java/net/minecraft/client/option/Option.java
+++ b/game/client/src/main/java/net/minecraft/client/option/Option.java
@@ -2,19 +2,22 @@ package net.minecraft.client.option;
 
 import net.minecraft.client.gui.paged.CallbackComponent;
 import net.minecraft.core.lang.I18n;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.ArrayList;
 import java.util.List;
 
+import static net.minecraft.core.util.Util.emptyStringIfNull;
+
 public abstract class Option<E> {
 
-	public final GameSettings gameSettings;
-	public final String name;
-	public E value;
-	protected final E defaultValue;
+	public final @NotNull GameSettings gameSettings;
+	public final @NotNull String name;
+	public @NotNull E value;
+	protected final @NotNull E defaultValue;
 	protected final List<OptionCallback<E>> callbacks = new ArrayList<>();
 
-	public Option(GameSettings gameSettings, String name, E defaultValue) {
+	public Option(final @NotNull GameSettings gameSettings, final @NotNull String name, final @NotNull E defaultValue) {
 		this.gameSettings = gameSettings;
 		this.name = name;
 		this.value = defaultValue;
@@ -22,47 +25,47 @@ public abstract class Option<E> {
 		GameSettings.options.add(this);
 	}
 
-	public void set(E value) {
+	public void set(final @NotNull E value) {
 		this.value = value;
 	}
 
-	public void addCallback(OptionCallback<E> callback) {
+	public void addCallback(final @NotNull OptionCallback<E> callback) {
 		this.callbacks.add(callback);
 	}
 
-	public abstract void parse(String string);
+	public abstract void parse(final @NotNull String string);
 
 	public void onUpdate() {
-		for (final OptionCallback<E> callback : this.callbacks) {
+		for (final @NotNull OptionCallback<E> callback : this.callbacks) {
 			callback.onUpdate(this);
 		}
-        gameSettings.optionChanged(this);
+        this.gameSettings.optionChanged(this);
     }
 
-	public String getDisplayString() {
-        return gameSettings.getDisplayString(this);
+	public @NotNull String getDisplayString() {
+        return this.gameSettings.getDisplayString(this);
     }
 
-	public String getDisplayStringValue() {
-        return gameSettings.getDisplayString(this);
+	public @NotNull String getDisplayStringValue() {
+        return this.gameSettings.getDisplayString(this);
     }
 
-	public String getDisplayStringName() {
+	public @NotNull String getDisplayStringName() {
 		return I18n.getInstance().translateKey("options." + this.name);
 	}
 
 	/**
 	 * The String that is saved to the options.txt file. Don't include spaces!
 	 */
-	public String getValueString() {
-		return value.toString();
+	public @NotNull String getValueString() {
+		return emptyStringIfNull(this.value.toString());
 	}
 
-	public E getDefaultValue() {
-		return defaultValue;
+	public @NotNull E getDefaultValue() {
+		return this.defaultValue;
 	}
 
-	public static interface OptionCallback<T> {
-		public void onUpdate(Option<T> option);
+	public interface OptionCallback<T> {
+		void onUpdate(Option<T> option);
 	}
 }
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionBoolean.java b/game/client/src/main/java/net/minecraft/client/option/OptionBoolean.java
index cf9d3ec47..876d9dce4 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionBoolean.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionBoolean.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.option;
 
 import net.minecraft.core.util.helper.Toggleable;
+import org.jetbrains.annotations.NotNull;
 
 public class OptionBoolean extends OptionToggleable<Boolean> implements Toggleable{
 	
@@ -15,7 +16,7 @@ public class OptionBoolean extends OptionToggleable<Boolean> implements Toggleab
 	}
 
 	@Override
-	public void parse(String string) {
+	public void parse(@NotNull String string) {
 		this.value = string.equalsIgnoreCase("true");
 	}
 
@@ -23,6 +24,9 @@ public class OptionBoolean extends OptionToggleable<Boolean> implements Toggleab
 	public boolean isSlider() {
 		return false;
 	}
-	
+
+	public boolean isTrue() {
+		return this.value != null && this.value;
+	}
 	
 }
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionColor.java b/game/client/src/main/java/net/minecraft/client/option/OptionColor.java
index 7ed3abb37..cecc457db 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionColor.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionColor.java
@@ -2,6 +2,7 @@ package net.minecraft.client.option;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.core.util.helper.Color;
+import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 
 public class OptionColor extends Option<Color>{
@@ -11,7 +12,7 @@ public class OptionColor extends Option<Color>{
 	}
 
 	@Override
-	public void parse(String string) {
+	public void parse(@NotNull String string) {
 		try{
 			this.value.parse(string);
 		}catch (Exception e) {
@@ -20,7 +21,7 @@ public class OptionColor extends Option<Color>{
 	}
 	
 	@Override
-	public String getValueString() {
+	public @NotNull String getValueString() {
 		return value.toPropertiesString();
 	}
 
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionEnum.java b/game/client/src/main/java/net/minecraft/client/option/OptionEnum.java
index 765155ba0..3693e8c04 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionEnum.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionEnum.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.option;
 
 import net.minecraft.core.util.helper.Toggleable;
+import org.jetbrains.annotations.NotNull;
 
 public class OptionEnum<E extends Enum<?>> extends OptionToggleable<E> implements Toggleable{
 	
@@ -15,7 +16,7 @@ public class OptionEnum<E extends Enum<?>> extends OptionToggleable<E> implement
 	}
 
 	@Override
-	public void parse(String string) {
+	public void parse(@NotNull String string) {
 		for(E e : values) {
 			if(e.toString().equalsIgnoreCase(string)) {
 				this.value = e;
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionFloat.java b/game/client/src/main/java/net/minecraft/client/option/OptionFloat.java
index 58c3e7619..61be56932 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionFloat.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionFloat.java
@@ -1,5 +1,7 @@
 package net.minecraft.client.option;
 
+import org.jetbrains.annotations.NotNull;
+
 public class OptionFloat extends Option<Float>{
 
 	public OptionFloat(GameSettings gameSettings, String name, float value) {
@@ -15,7 +17,7 @@ public class OptionFloat extends Option<Float>{
 	}
 
 	@Override
-	public void parse(String string) {
+	public void parse(@NotNull String string) {
 		if(string.equalsIgnoreCase("true")) {
 			this.value = 1.0f;
 			return;
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionFont.java b/game/client/src/main/java/net/minecraft/client/option/OptionFont.java
index 588d258d1..6e4de8fdb 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionFont.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionFont.java
@@ -13,7 +13,7 @@ public class OptionFont extends OptionToggleable<@NotNull Font> implements Toggl
     }
 
     @Override
-    public void parse(final String string) {
+    public void parse(final @NotNull String string) {
         this.value = Fonts.fontWithKey(string);
     }
 
@@ -48,7 +48,7 @@ public class OptionFont extends OptionToggleable<@NotNull Font> implements Toggl
     }
 
     @Override
-    public String getValueString() {
+    public @NotNull String getValueString() {
         return this.value.getKey();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionInteger.java b/game/client/src/main/java/net/minecraft/client/option/OptionInteger.java
index 20c8d2df2..254c6b368 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionInteger.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionInteger.java
@@ -1,5 +1,7 @@
 package net.minecraft.client.option;
 
+import org.jetbrains.annotations.NotNull;
+
 public class OptionInteger extends Option<Integer>{
 
 	public OptionInteger(GameSettings gameSettings, String name, int defaultValue) {
@@ -7,7 +9,7 @@ public class OptionInteger extends Option<Integer>{
 	}
 
 	@Override
-	public void parse(String string) {
+	public void parse(@NotNull String string) {
 		this.value = Integer.parseInt(string);
 	}
 
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionRange.java b/game/client/src/main/java/net/minecraft/client/option/OptionRange.java
index 0ef3a71a3..aeb1244b9 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionRange.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionRange.java
@@ -1,5 +1,7 @@
 package net.minecraft.client.option;
 
+import org.jetbrains.annotations.NotNull;
+
 public class OptionRange extends OptionToggleable<Integer> {
 	public final int highest;
 	public final int lowest;
@@ -15,7 +17,7 @@ public class OptionRange extends OptionToggleable<Integer> {
 	}
 
 	@Override
-	public void parse(String string) {
+	public void parse(@NotNull String string) {
 		this.value = Integer.parseInt(string);
 	}
     
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionString.java b/game/client/src/main/java/net/minecraft/client/option/OptionString.java
index 422af38c1..e69745bdb 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionString.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionString.java
@@ -1,5 +1,7 @@
 package net.minecraft.client.option;
 
+import org.jetbrains.annotations.NotNull;
+
 public class OptionString extends Option<String>{
 
 	public OptionString(GameSettings gameSettings, String name, String defaultValue) {
@@ -7,7 +9,7 @@ public class OptionString extends Option<String>{
 	}
 
 	@Override
-	public void parse(String string) {
+	public void parse(@NotNull String string) {
 		this.value = string;
 	}
 
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionTooltip.java b/game/client/src/main/java/net/minecraft/client/option/OptionTooltip.java
index cff0d83a4..6905430a7 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionTooltip.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionTooltip.java
@@ -3,6 +3,7 @@ package net.minecraft.client.option;
 import net.minecraft.client.gui.TooltipElement;
 import net.minecraft.client.render.dynamictexture.DynamicTexture;
 import net.minecraft.core.util.helper.Toggleable;
+import org.jetbrains.annotations.NotNull;
 
 public class OptionTooltip extends OptionToggleable<String> implements Toggleable {
 
@@ -11,7 +12,7 @@ public class OptionTooltip extends OptionToggleable<String> implements Toggleabl
     }
 
     @Override
-    public void parse(final String string) {
+    public void parse(final @NotNull String string) {
         this.value = string;
     }
 
